#include <compiler.h>

using namespace LTF;

Program::Program() {
	this->types = new std::map<std::string, Type *>();
	this->code = new std::vector<CodeAST *>();
	this->variables = new std::map<std::string, VariableAST *>();
}

void Program::addType(Type *c) {
	this->types->insert(std::pair<std::string, Type *>(*c->Name, c));
}

Type *Program::findType(std::string *s) {
	if(this->types->find(*s) != this->types->end()) {
		return this->types->find(*s)->second;
	}
	return NULL;
}

std::map<std::string, Type *>::iterator Program::getTypeIterBegin() {
	return this->types->begin();
}

std::map<std::string, Type *>::iterator Program::getTypeIterEnd() {
	return this->types->end();
}

void Program::addOperation(CodeAST *c) {
	this->code->push_back(c);
}

bool Program::addVariable(VariableAST *v) {
	if(v == NULL || this->variables->find(*v->getName()) != this->variables->end()) return false;
	this->variables->insert(std::pair<std::string, VariableAST *>(*v->getName(), v));
	return true;
}

VariableAST *Program::findVariable(std::string *s) {
	if(this->variables->find(*s) != this->variables->end()) {
		return this->variables->find(*s)->second;
	}
	return NULL;
}

std::map<std::string, VariableAST *>::iterator Program::getVariableIterBegin() {
	return this->variables->begin();
}

std::map<std::string, VariableAST *>::iterator Program::getVariableIterEnd() {
	return this->variables->end();
}

